#include	<windows.h>
#include	<windowsx.h>
#include	<commctrl.h>
#include	<commdlg.h>
#include	<tchar.h>
#include	"basewin.h"
#include	"resource.h"
#include	"dialog.h"

#if _WIN32_WCE < 211
#define WCE20			1
#endif

#define FAMILYMAX   64
#define FPOINTMAX   32

typedef struct {
	int	  nNumFonts;
	TCHAR szFontFamily[LF_FACESIZE];
	LONG  aFontPoint[FPOINTMAX];
} FONTFAMSTRUCT;

static HDC shDC = 0;
static INT sFamilyCnt = 0;
static FONTFAMSTRUCT ffs[FAMILYMAX];

int	  s_FontSize;
TCHAR s_FontName[LF_FACESIZE];
HFONT g_hUsrFont = 0;

extern SIZE  g_size;
extern int   g_FontSize;
extern TCHAR g_FontName[LF_FACESIZE];

LRESULT OptionNotifyProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam);

//---------------------------------------------------------------
//	gpłtHg񋓂
static int CALLBACK FontFamilyCallback (
CONST LOGFONT *lplf,
CONST TEXTMETRIC *lpntm,
DWORD nFontType, 
LPARAM lParam
) {
	// z̗vfől𒴂ꍇA񋓂~
	if (sFamilyCnt >= FAMILYMAX)
		return 0;

	// tHg̖̏Rs[
	lstrcpy (ffs[sFamilyCnt++].szFontFamily, lplf->lfFaceName);

    return 1;
}

//---------------------------------------------------------------
//	TrueTypetHg̏ꍇAgpłTCYߑł
static void DefTrueTypeSize (FONTFAMSTRUCT* pffs)
{
	int aPoint[] = {6,8,9,10,11,12,14,16,18,20,22,24,0};
	int i;
	for (i = 0; aPoint[i] != 0; i++) {
		pffs->aFontPoint[pffs->nNumFonts] = aPoint[i];
		pffs->nNumFonts++;
	}
}

//---------------------------------------------------------------
static int CALLBACK EnumSingleFontFamily (
CONST LOGFONT *lplf, 
CONST TEXTMETRIC *lpntm, 
DWORD nFontType,
LPARAM lParam
) {
	FONTFAMSTRUCT* pffs;
	LONG lPoint;
	int i;

	pffs = (FONTFAMSTRUCT*)lParam;

    // z̗vfől𒴂ꍇA񋓂~
    if (pffs->nNumFonts >= FPOINTMAX)
        return 0;

	if (pffs->nNumFonts == 0 && (
#ifdef _WIN32_WCE
		lplf->lfClipPrecision == CLIP_STROKE_PRECIS
#else
		lplf->lfOutPrecision == OUT_TT_PRECIS ||
		lplf->lfOutPrecision == OUT_OUTLINE_PRECIS ||
		lplf->lfOutPrecision == OUT_STROKE_PRECIS
#endif
		))
		DefTrueTypeSize (pffs);

	lPoint = (lplf->lfHeight * 720) / GetDeviceCaps(shDC,LOGPIXELSY);
	//ľܓ
	pffs->aFontPoint[pffs->nNumFonts] = (lPoint / 10) + ((lPoint % 10 >= 5)?1:0);

	for (i = 0; i < pffs->nNumFonts; i++) {
		if (pffs->aFontPoint[i] == pffs->aFontPoint[pffs->nNumFonts])
			return 1;
	}

	// t@~̃tHg̃JE^CNg
	pffs->nNumFonts++;
	return 1;
}

//---------------------------------------------------------------
//	tHgTCYXg\
static void SetFontSizeList (HWND hWnd)
{
	INT i;
	HWND hItem;
	TCHAR buf[32];
	INT nIndex;

	//tHg
	hItem = GetDlgItem (hWnd, IDC_LISTNAME);
	//I擾
	nIndex = SendMessage (hItem, LB_GETCURSEL, 0, 0);

	//tHgTCY
	hItem = GetDlgItem (hWnd, IDC_LISTSIZE);
	SendMessage (hItem, LB_RESETCONTENT, 0, 0);

	//tHgIĂΉTCY
	if (nIndex != -1) {
		for (i = 0; i < ffs[nIndex].nNumFonts; i++) {
			wsprintf (buf, TEXT("%2d"), ffs[nIndex].aFontPoint[i]);
			SendMessage (hItem, LB_ADDSTRING, 0, (LPARAM)buf);
		}
	}
}

//---------------------------------------------------------------
static void GetSelectFont (HWND hWnd)
{
	HWND hItem;
	TCHAR buf[LF_FACESIZE];
	INT nIndex = -1;
	INT iSize;

	//tHg
	hItem = GetDlgItem (hWnd, IDC_LISTNAME);
	nIndex = SendMessage (hItem, LB_GETCURSEL, 0, 0);
	if (nIndex != -1) {
		SendMessage (hItem, LB_GETTEXT, nIndex, (LPARAM)s_FontName);
	}

	//tHgTCY
	hItem = GetDlgItem (hWnd, IDC_LISTSIZE);
	nIndex = SendMessage (hItem, LB_GETCURSEL, 0, 0);
	if (nIndex != -1) {
		SendMessage (hItem, LB_GETTEXT, nIndex, (LPARAM)buf);
	}
	else {
		GetWindowText (hItem, buf, LF_FACESIZE);
	}
	iSize = _wtoi (buf);
	if (iSize) s_FontSize = iSize;
}

//----------------------------------------------------------
static HFONT CreateEditFont(HWND hWnd, TCHAR *FontName, int FontSize)
{
	LOGFONT FT;
	memset (&FT, 0, sizeof(LOGFONT));

	HDC hdc;
	hdc = GetDC(hWnd);
	FT.lfHeight = -(int)((FontSize * GetDeviceCaps(hdc,LOGPIXELSY)) / 72);
	ReleaseDC(hWnd, hdc);

	FT.lfWidth          = 0;
	FT.lfEscapement     = 0;
	FT.lfOrientation    = 0;
	FT.lfWeight         = 0;
	FT.lfItalic         = FALSE;
	FT.lfUnderline      = FALSE;
	FT.lfStrikeOut      = FALSE;
	FT.lfCharSet        = SHIFTJIS_CHARSET;
	FT.lfOutPrecision   = OUT_DEFAULT_PRECIS;
	FT.lfClipPrecision  = CLIP_DEFAULT_PRECIS;
	FT.lfQuality        = 0;
	FT.lfPitchAndFamily = DEFAULT_PITCH;
	wcscpy (FT.lfFaceName, FontName);

#ifndef WCE20
	{	//CE2.11ȍ~Ɍ肷
		OSVERSIONINFO oi;
		memset (&oi, 0, sizeof(OSVERSIONINFO));
		oi.dwOSVersionInfoSize = sizeof(OSVERSIONINFO);
		GetVersionEx (&oi);
		if (oi.dwMajorVersion > 2 ||
			(oi.dwMajorVersion == 2 && oi.dwMinorVersion > 1)) {
			//IMẼtHg
			HIMC hImc;
			hImc = ImmGetContext(hWnd);
			ImmSetCompositionFont(hImc,&FT);
			ImmReleaseContext(hWnd, hImc);
		}
	}
#endif

	return CreateFontIndirect((CONST LOGFONT *)&FT);
}

//---------------------------------------------------------------
void FontSetup (HWND hWnd)
{
	g_size.cx = 10;
	g_size.cy = 20;

	if (g_hUsrFont) {
		DeleteObject (g_hUsrFont);
		g_hUsrFont = 0;
	}
	if (g_FontName[0] != 0 && g_FontSize != 0) {
		g_hUsrFont = CreateEditFont (hWnd, g_FontName, g_FontSize);
	}

	if (g_hUsrFont) {
		HDC hDC = GetDC (hWnd);
		int lfHeight = (int)((g_FontSize * GetDeviceCaps(hDC,LOGPIXELSY)) / 72);
		if (lfHeight < 0) lfHeight = -lfHeight;
		g_size.cx = lfHeight / 2;
		g_size.cy = lfHeight;
		//GetTextExtentPoint32 (hDC, TEXT("A"), 1, &g_size);
		ReleaseDC (hWnd, hDC);
	}
//	TCHAR buf[80];
//	wsprintf (buf, TEXT("%d,%d"), g_size.cx, g_size.cy);
//	MessageBox (hWnd, buf, TEXT("debug"), MB_OK);
}

//---------------------------------------------------------------
static int OnInitdialog (HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	HWND hItem;
	int rc;
	int i;
	TCHAR buf[80];

	lstrcpy (s_FontName, g_FontName);
	s_FontSize = g_FontSize;

	shDC = GetDC (hDlg);

	// gpłtHg񋓂
	sFamilyCnt = 0;
	rc = EnumFontFamilies (shDC, NULL, FontFamilyCallback, 0);

	//tHgXg\
	hItem = GetDlgItem (hDlg, IDC_LISTNAME);
	int nIndex = -1;
	for (i = 0; i < sFamilyCnt; i++) {
		SendMessage (hItem, LB_ADDSTRING, 0, (LPARAM)ffs[i].szFontFamily);
		if (wcscmp (s_FontName, ffs[i].szFontFamily) == 0) nIndex = i;
		//tHgTCY񋓂
		ffs[i].nNumFonts = 0;
		rc = EnumFontFamilies (shDC, ffs[i].szFontFamily, 
			EnumSingleFontFamily, (LPARAM)(FONTFAMSTRUCT*)&ffs[i]);
	}
	//tHgI
	SendMessage (hItem, LB_SELECTSTRING, -1, (LPARAM)s_FontName);

	ReleaseDC (hDlg, shDC);

	//tHgTCYXg\
	SetFontSizeList (hDlg);

	//tHgTCYI
	hItem = GetDlgItem (hDlg, IDC_LISTSIZE);
	wsprintf (buf, TEXT("%2d"), s_FontSize);
	rc = SendMessage (hItem, LB_SELECTSTRING, -1, (LPARAM)buf);
	if (rc == CB_ERR) {
		rc = SendMessage (hItem, LB_SELECTSTRING, -1, (LPARAM)"10");
		if (rc == CB_ERR) rc = SendMessage (hItem, LB_SELECTSTRING, -1, (LPARAM)"14");
		if (rc == CB_ERR) rc = SendMessage (hItem, LB_SELECTSTRING, -1, (LPARAM)" 8");
	}

	return TRUE;
}

//---------------------------------------------------------------
static int OnCmdOk (HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	//tHg
	GetSelectFont (hDlg);

	lstrcpy (g_FontName, s_FontName);
	g_FontSize = s_FontSize;

	return TRUE;
}

//---------------------------------------------------------------
BOOL CALLBACK FontDlgProc( HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam )
{
	switch (message)
	{
	case WM_INITDIALOG:
		return OnInitdialog (hDlg, message, wParam, lParam);

	case WM_COMMAND:
		switch (LOWORD(wParam)) {
		case IDC_LISTNAME:
			if (HIWORD(wParam) == CBN_SELCHANGE) {
				HWND hItem;
				TCHAR buf[32];
				int rc;
				SetFontSizeList (hDlg);
				hItem = GetDlgItem (hDlg, IDC_LISTSIZE);
				wsprintf (buf, TEXT("%2d"), g_FontSize);
				rc = SendMessage (hItem, LB_SELECTSTRING, -1, (LPARAM)buf);
				if (rc == CB_ERR) {
					rc = SendMessage (hItem, LB_SELECTSTRING, -1, (LPARAM)"10");
					if (rc == CB_ERR) rc = SendMessage (hItem, LB_SELECTSTRING, -1, (LPARAM)"14");
					if (rc == CB_ERR) rc = SendMessage (hItem, LB_SELECTSTRING, -1, (LPARAM)" 8");
				}
			}
			break;

		case IDOK:
			OnCmdOk (hDlg, message, wParam, lParam);

		case IDCANCEL:
		//	EndDialog(hDlg, LOWORD(wParam));
			return TRUE;

		}
		break;

	case WM_NOTIFY:
		return OptionNotifyProc(hDlg, message, wParam, lParam);
	}
    return FALSE;
}

//---------------------------------------------------------------
/*
int DlgFont (HINSTANCE hInst, HWND hWnd)
{
	lstrcpy (s_FontName, g_FontName);
	s_FontSize = g_FontSize;

	int rc = DialogBox (hInst, (LPCTSTR)IDD_DLG_FONT, hWnd, (DLGPROC)FontDlgProc);
	if (rc == IDOK) {
		lstrcpy (g_FontName, s_FontName);
		g_FontSize = s_FontSize;

		FontSetup (hWnd);
	}

	return rc;
}
*/
//---------------------------------------------------------------
//---------------------------------------------------------------
