#include	<windows.h>
#include	<windowsx.h>
#include	<commctrl.h>
#include	<commdlg.h>
#include	<tchar.h>
#include	"basewin.h"
#include	"resource.h"
#include	"dialog.h"

extern HWND g_hWndMain;
extern "C" {
extern DWORD g_dwHotKey;
};

extern BOOL	(*g_pRegisterHotKey)( HWND hWnd, int id, UINT fsModifiers, UINT vk );
extern BOOL	(*g_pUnregisterHotKey)( HWND hWnd, int id );

LRESULT OptionNotifyProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam);

struct {
	int 	vkcode;
	TCHAR	name[16];
}	vk_tbl[] = {
	VK_TAB    , L"TAB",
	VK_RETURN , L"RET",
	VK_ESCAPE , L"ESC",
	VK_SPACE  , L"SPC",
	VK_BACK   , L"BS",
	VK_LEFT   , L"LEFT",
	VK_RIGHT  , L"RIGHT",
	VK_UP     , L"UP",
	VK_DOWN   , L"DOWN",
	VK_DELETE , L"DEL",
	VK_INSERT , L"INS",
	VK_PRIOR  , L"PREV",
	VK_NEXT   , L"NEXT",
	VK_END    , L"END",
	VK_HOME   , L"HOME",
	0x1D      , L"NOCNV",
	0x15      , L"KANA",
	0x19      , L"KANJI",
	0         , L"",
};

TCHAR* VkGetName (WORD wKey)
{
	static TCHAR buf[8];

	if ((wKey >= '0' && wKey <= '9')||(wKey >= 'A' && wKey <= 'Z')) {
		wsprintf (buf, TEXT("%c"), wKey);
		return buf;
	}
	
	for (int i = 0; vk_tbl[i].vkcode != 0; i++) {
		if (vk_tbl[i].vkcode == wKey)
			return vk_tbl[i].name;
	}

	wsprintf (buf, TEXT("0x%02X"), wKey);
	return buf;
}

int VkGetCode (TCHAR* szKey)
{
	int wKey;
	if (wcsnicmp(szKey, L"0x",2) == 0) {
		swscanf (&szKey[2], TEXT("%x"), &wKey);
		return wKey;
	}

	for (int i = 0; vk_tbl[i].vkcode != 0; i++) {
		if (wcsicmp(vk_tbl[i].name, szKey) == 0) {
			return vk_tbl[i].vkcode;
		}
	}

	if ((szKey[0] >= L'0' && szKey[0] <= L'9')||
		(szKey[0] >= L'A' && szKey[0] <= L'Z')) {
		wKey = szKey[0];
		return wKey;
	}

	return 0;
}

//---------------------------------------------------------------
static int OnInitdialog (HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	HWND hItem;
	//TCHAR buf[80];

	WORD wKey = LOWORD(g_dwHotKey);
	hItem = GetDlgItem (hDlg, IDC_EVKCODE);
	SetWindowText (hItem, VkGetName(wKey));

	int wAlt = HIWORD(g_dwHotKey);
	if (wAlt & MOD_ALT) {
		hItem = GetDlgItem (hDlg, IDC_CALT);
		SendMessage (hItem, BM_SETCHECK, 1, 0);
	}
	if (wAlt & MOD_WIN) {
		hItem = GetDlgItem (hDlg, IDC_CWIN);
		SendMessage (hItem, BM_SETCHECK, 1, 0);
	}
	if (wAlt & MOD_CONTROL) {
		hItem = GetDlgItem (hDlg, IDC_CCTRL);
		SendMessage (hItem, BM_SETCHECK, 1, 0);
	}
	if (wAlt & MOD_SHIFT) {
		hItem = GetDlgItem (hDlg, IDC_CSHIFT);
		SendMessage (hItem, BM_SETCHECK, 1, 0);
	}

	return TRUE;
}

//---------------------------------------------------------------
static int OnCmdOk (HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	int rc;
	HWND hItem;
	TCHAR buf[80];

	hItem = GetDlgItem (hDlg, IDC_EVKCODE);
	GetWindowText (hItem, buf, sizeof(buf)/sizeof(TCHAR));

	int wKey;
	//swscanf (buf, TEXT("%x"), &wKey);
	wKey = VkGetCode (buf);

	int wAlt = 0;
	hItem = GetDlgItem (hDlg, IDC_CALT);
	rc = SendMessage (hItem, BM_GETCHECK, 0, 0);
	if (rc) wAlt |= MOD_ALT;
	hItem = GetDlgItem (hDlg, IDC_CWIN);
	rc = SendMessage (hItem, BM_GETCHECK, 0, 0);
	if (rc) wAlt |= MOD_WIN;
	hItem = GetDlgItem (hDlg, IDC_CCTRL);
	rc = SendMessage (hItem, BM_GETCHECK, 0, 0);
	if (rc) wAlt |= MOD_CONTROL;
	hItem = GetDlgItem (hDlg, IDC_CSHIFT);
	rc = SendMessage (hItem, BM_GETCHECK, 0, 0);
	if (rc) wAlt |= MOD_SHIFT;

	DWORD dwHotKey = MAKELONG(wKey, wAlt);
	if (dwHotKey != g_dwHotKey) {
	//	wsprintf(buf, TEXT("%04X"), dwHotKey);
	//	MessageBox (NULL, buf, TEXT("deb"), MB_OK);
#ifdef	_WIN32_WCE
		if ( g_pUnregisterHotKey ) {
			/* zbgL[ */
			if (g_dwHotKey) {
				(*g_pUnregisterHotKey)( g_hWndMain, 0x0000 ) ;
			}
			g_dwHotKey = 0;
		}
#endif
		g_dwHotKey = dwHotKey;
		/* zbgL[o^ */
		if ( g_pRegisterHotKey && g_dwHotKey ) {
#ifdef	_WIN32_WCE
			(*g_pRegisterHotKey)( g_hWndMain, 0x0000, HIWORD(g_dwHotKey), LOWORD(g_dwHotKey) ) ;
#endif
		} else {
			g_dwHotKey = 0 ;
		}
	}
	
	return TRUE;
}

//---------------------------------------------------------------
BOOL CALLBACK HotkeyDlgProc( HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam )
{
	switch (message)
	{
	case WM_INITDIALOG:
		return OnInitdialog (hDlg, message, wParam, lParam);

	case WM_COMMAND:
		switch (LOWORD(wParam)) {
		case IDOK:
			OnCmdOk (hDlg, message, wParam, lParam);
		case IDCANCEL:
		//	EndDialog(hDlg, LOWORD(wParam));
			return TRUE;

		}
		break;
	case WM_NOTIFY:
		return OptionNotifyProc(hDlg, message, wParam, lParam);
	}
    return FALSE;
}

//---------------------------------------------------------------
/*
int DlgHotkey (HINSTANCE hInst, HWND hWnd)
{
	return DialogBox (hInst, (LPCTSTR)IDD_DLG_HKEY, hWnd, (DLGPROC)HotkeyDlgProc);
}
*/
//---------------------------------------------------------------
//---------------------------------------------------------------
