#include	<windows.h>
#include	<windowsx.h>
#include	<commctrl.h>
#include	<commdlg.h>
#include	<tchar.h>
#include	"basewin.h"
#include	"resource.h"
#include	"dialog.h"

extern "C" {
extern DWORD g_PasteKey;
extern int	 g_EnteyWin;
};
extern HWND s_hWndTerget;

#define sjis2unicode(sjis, unicode, len)	MultiByteToWideChar(CP_ACP, 0, (char*)sjis, -1, unicode, len)
#define unicode2sjis(unicode, sjis, len)	WideCharToMultiByte(CP_ACP, 0, unicode, -1, (char*)sjis, len, NULL, NULL)

int fGetLine (BYTE* mbs, int size, DWORD* pdwPoint, BYTE* pBuf, DWORD dwSize);
int Param_Branch (BYTE* buf, BYTE* av[]);
void Param_Free (int ac, BYTE* av[]);

typedef struct 	{
	TCHAR name[32];
	TCHAR clas[32];
	TCHAR idcs[32];
	int   id;
	DWORD key;
}	TGWND;

#define MAX_WNDTYP	32

TGWND	s_wk;
TGWND	g_WndTyp[MAX_WNDTYP];

extern TCHAR g_bDebug[256];

/*
[E1]
NAME = ""
CLASS = ""
ID = 0
KEY = ^V
*/

//---------------------------------------------------------------
static int OnInitdialog (HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	HWND hItem;
	TCHAR buf[MAX_PATH];

	hItem = GetDlgItem (hDlg, IDC_ENAME);
	SetWindowText (hItem, s_wk.name);

	hItem = GetDlgItem (hDlg, IDC_ECLASS);
	SetWindowText (hItem, s_wk.clas);

	wsprintf (buf, _T("%d"), s_wk.id);
	hItem = GetDlgItem (hDlg, IDC_EID);
	SetWindowText (hItem, buf);

	hItem = GetDlgItem (hDlg, IDC_ECCLS);
	SetWindowText (hItem, s_wk.idcs);

	int alt = HIWORD(s_wk.key);
	int key = LOWORD(s_wk.key);
	buf[0] = 0;
	if (alt & MOD_ALT) lstrcat (buf, _T("%"));
	if (alt & MOD_SHIFT) lstrcat (buf, _T("+"));
	if (alt & MOD_CONTROL) lstrcat (buf, _T("^"));
	lstrcat (buf, (TCHAR*)&key);

	hItem = GetDlgItem (hDlg, IDC_EPKEY);
	SetWindowText (hItem, buf);

	return TRUE;
}

//---------------------------------------------------------------
static int OnCmdOk (HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	HWND hItem;
	TCHAR buf[80];

	hItem = GetDlgItem (hDlg, IDC_ENAME);
	GetWindowText (hItem, s_wk.name, sizeof(s_wk.name)/sizeof(TCHAR));

	hItem = GetDlgItem (hDlg, IDC_ECLASS);
	GetWindowText (hItem, s_wk.clas, sizeof(s_wk.clas)/sizeof(TCHAR));

	hItem = GetDlgItem (hDlg, IDC_EID);
	GetWindowText (hItem, buf, sizeof(buf)/sizeof(TCHAR));
	s_wk.id = _wtoi(buf);

	hItem = GetDlgItem (hDlg, IDC_ECCLS);
	GetWindowText (hItem, s_wk.idcs, sizeof(s_wk.idcs)/sizeof(TCHAR));

	hItem = GetDlgItem (hDlg, IDC_EPKEY);
	GetWindowText (hItem, buf, sizeof(buf)/sizeof(TCHAR));

	int alt = 0;
	int key = 0;
	for (int j = 0; buf[j] != 0; j++) {
		if (buf[j] == '%') alt |= MOD_ALT;
		if (buf[j] == '+') alt |= MOD_SHIFT;
		if (buf[j] == '^') alt |= MOD_CONTROL;
		if (buf[j] >= 'a' && buf[j] <= 'z')
			buf[j] -= 0x20;
		if (buf[j] >= 'A' && buf[j] <= 'Z') {
			key = buf[j];
			break;
		}
	}
	s_wk.key = MAKELONG(key, alt);

	return TRUE;
}

//---------------------------------------------------------------
BOOL CALLBACK EntwinDlgProc( HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam )
{
	switch (message)
	{
	case WM_INITDIALOG:
		return OnInitdialog (hDlg, message, wParam, lParam);

	case WM_COMMAND:
		switch (LOWORD(wParam)) {
		case IDOK:
		case IDC_BDEL:
			OnCmdOk (hDlg, message, wParam, lParam);
		case IDCANCEL:
			EndDialog(hDlg, LOWORD(wParam));
			return TRUE;

		}
		break;
	}
    return FALSE;
}

//---------------------------------------------------------------
int LoadWndentry (HINSTANCE hInstance)
{
	memset (g_WndTyp, 0, sizeof(g_WndTyp));

	TCHAR buf[MAX_PATH];
	GetModuleFileName (hInstance, buf, MAX_PATH);
	{
		TCHAR* p = wcsrchr (buf, TEXT('\\'));
		if (p != 0) *(p+1) = 0;
	}

	//ݒt@C
	TCHAR cFileName[MAX_PATH];
	wsprintf (cFileName, TEXT("%sPQBox.wnd"), buf);

	//t@CJ
	HANDLE hFile;
	hFile = CreateFile (cFileName, GENERIC_READ,
		FILE_SHARE_READ | FILE_SHARE_WRITE, NULL, OPEN_EXISTING,
		0, (HANDLE)NULL);
	if (hFile == (HANDLE)INVALID_HANDLE_VALUE)
		return FALSE;

	//t@CTCY
	DWORD dwFileSize = GetFileSize (hFile, NULL);

	//[hobt@쐬
	BYTE* szData = (BYTE*)LocalAlloc (LPTR, dwFileSize+256);
	if (szData == 0) {
		CloseHandle(hFile);
		return NULL;
	}

	//f[^ǂݍ
	DWORD dwSize;
	ReadFile (hFile, szData, dwFileSize, &dwSize, NULL);

	//t@C
	CloseHandle (hFile);

	int i;
	int rc;
	DWORD dwPoint = 0;
	BYTE  mbs[128];
	int ac;
	BYTE* av[16+1];
	int no = 0;

	for (i = 0; i < 256; i++) {
		rc = fGetLine (mbs, 100-1, &dwPoint, szData, dwFileSize);
		if (rc > 0 && mbs[0] == '[') {
			no = (mbs[1] & 0x0f) * 10 + (mbs[2] & 0x0f);
		}
		if (no < 1 || no > 15 || rc <= 0 || mbs[0] == '#') {
			if (dwPoint >= dwFileSize) break;
			continue;
		}
		ac = Param_Branch (mbs, av);
		if (ac >= 2) {
			if (memcmp (av[0],"NAME",4) == 0)
				sjis2unicode (av[1], g_WndTyp[no-1].name, sizeof g_WndTyp[no-1].name);
			if (memcmp (av[0],"CLAS",4) == 0)
				sjis2unicode (av[1], g_WndTyp[no-1].clas, sizeof g_WndTyp[no-1].clas);
			if (memcmp (av[0],"ID",2) == 0) {
				TCHAR unicode[80];
				sjis2unicode (av[1], unicode, sizeof unicode);
				g_WndTyp[no-1].id = _wtoi(unicode);
			}
			if (memcmp (av[0],"IDCS",4) == 0)
				sjis2unicode (av[1], g_WndTyp[no-1].idcs, sizeof g_WndTyp[no-1].idcs);
			if (memcmp (av[0],"KEY",3) == 0) {
				int alt = 0;
				int key = 0;
				BYTE* p = av[1];
				for (int j = 0; p[j] != 0; j++) {
					if (p[j] == '%') alt |= MOD_ALT;
					if (p[j] == '+') alt |= MOD_SHIFT;
					if (p[j] == '^') alt |= MOD_CONTROL;
					if (p[j] >= 'a' && p[j] <= 'z')
						p[j] -= 0x20;
					if (p[j] >= 'A' && p[j] <= 'Z')
						key = p[j];
				}
				g_WndTyp[no-1].key = MAKELONG(key, alt);
			}
		}
		Param_Free (ac, av);
		if (dwPoint >= dwFileSize) break;
	}

	//J
	LocalFree ((HANDLE)szData);

	return TRUE;
}

//---------------------------------------------------------------
int SaveWndentry (HINSTANCE hInstance)
{
	TCHAR unicode[MAX_PATH];
	BYTE  sjis[MAX_PATH];

	GetModuleFileName (hInstance, unicode, MAX_PATH);
	{
		TCHAR* p = wcsrchr (unicode, TEXT('\\'));
		if (p != 0) *(p+1) = 0;
	}

	//ݒt@C
	TCHAR cFileName[MAX_PATH];
	wsprintf (cFileName, TEXT("%sPQBox.wnd"), unicode);
	DeleteFile (cFileName);

	//t@CJ
	HANDLE hFile;
	hFile = CreateFile (cFileName, GENERIC_WRITE,
		FILE_SHARE_READ | FILE_SHARE_WRITE, NULL, CREATE_ALWAYS,
		0, (HANDLE)NULL);
	if (hFile == (HANDLE)INVALID_HANDLE_VALUE)
		return FALSE;

	int i;
	int len;
	DWORD dwSize;
	for (i = 0; i < MAX_WNDTYP; i++) {
		if (g_WndTyp[i].name[0] == 0)
			continue;

		wsprintf (unicode, _T("\r\n[%02d]\r\n"), i+1);
		unicode2sjis (unicode, sjis, sizeof sjis);
		len = strlen ((char*)sjis);
		WriteFile (hFile, sjis, len, &dwSize, NULL);

		wsprintf (unicode, _T("NAME = \"%s\"\r\n"), g_WndTyp[i].name);
		unicode2sjis (unicode, sjis, sizeof sjis);
		len = strlen ((char*)sjis);
		WriteFile (hFile, sjis, len, &dwSize, NULL);

		wsprintf (unicode, _T("CLAS = \"%s\"\r\n"), g_WndTyp[i].clas);
		unicode2sjis (unicode, sjis, sizeof sjis);
		len = strlen ((char*)sjis);
		WriteFile (hFile, sjis, len, &dwSize, NULL);

		wsprintf (unicode, _T("ID = %d\r\n"), g_WndTyp[i].id);
		unicode2sjis (unicode, sjis, sizeof sjis);
		len = strlen ((char*)sjis);
		WriteFile (hFile, sjis, len, &dwSize, NULL);

		wsprintf (unicode, _T("IDCS = \"%s\"\r\n"), g_WndTyp[i].idcs);
		unicode2sjis (unicode, sjis, sizeof sjis);
		len = strlen ((char*)sjis);
		WriteFile (hFile, sjis, len, &dwSize, NULL);

		strcpy ((char*)sjis, "KEY = ");
		len = strlen ((char*)sjis);
		WriteFile (hFile, sjis, len, &dwSize, NULL);

		int alt = HIWORD(g_WndTyp[i].key);
		int key = LOWORD(g_WndTyp[i].key);
		unicode[0] = 0;
		if (alt & MOD_ALT) lstrcat (unicode, _T("%"));
		if (alt & MOD_SHIFT) lstrcat (unicode, _T("+"));
		if (alt & MOD_CONTROL) lstrcat (unicode, _T("^"));
		lstrcat (unicode, (TCHAR*)&key);
		unicode2sjis (unicode, sjis, sizeof sjis);
		len = strlen ((char*)sjis);
		strcpy ((char*)&sjis[len], "\r\n");
		len += 2;
		WriteFile (hFile, sjis, len, &dwSize, NULL);
	}

	CloseHandle (hFile);
	return TRUE;
}
//---------------------------------------------------------------
int SeachEntwin (HWND hWndSend, HWND hWndTagt)
{
	int i;
	HWND hItem;
	TGWND	s_wk;

	if (!hWndSend) return -1;

	g_PasteKey = 'V';
	g_EnteyWin = 0;

	GetWindowText(hWndSend, s_wk.name, sizeof(s_wk.name)/sizeof(TCHAR));
	GetClassName (hWndSend, s_wk.clas, sizeof(s_wk.clas)/sizeof(TCHAR));

	if (hWndTagt) {
		s_wk.id = GetWindowLong (hWndTagt, GWL_ID);
	}
	else {
		s_wk.id = -1;
	}

	int idx = -1;
	for (i = 0; i < MAX_WNDTYP; i++) {
		if (lstrcmp(g_WndTyp[i].name, s_wk.name) == 0 &&
			lstrcmp(g_WndTyp[i].clas, s_wk.clas) == 0) {
			g_EnteyWin = TRUE;
			if (s_wk.id != -1 && g_WndTyp[i].id == s_wk.id) {
				idx = i;
				int key = g_WndTyp[idx].key & 0x7f;
				if (key) g_PasteKey = key;
			}
			else if (g_WndTyp[i].id >= 0) {
				hItem = GetDlgItem (hWndSend, g_WndTyp[i].id);
				if (hItem) {
					int id = GetWindowLong (hItem, GWL_ID);
					if (id == g_WndTyp[i].id) {
						s_hWndTerget = hItem;
						idx = i;
						int key = g_WndTyp[idx].key & 0x7f;
						if (key) g_PasteKey = key;
		wsprintf (g_bDebug, TEXT("%s(%s)"), g_WndTyp[i].name, g_WndTyp[i].clas);
						return idx;
					}
				}
			}
			else {
				idx = i;
			}
		}
	}
	if (idx != -1) {
		int key = g_WndTyp[idx].key & 0x7f;
		if (key) g_PasteKey = key;
		wsprintf (g_bDebug, TEXT("%s(%s)"), g_WndTyp[i].name, g_WndTyp[i].clas);
	}
	return idx;
}

//---------------------------------------------------------------
int DlgEntwin (HINSTANCE hInst, HWND hWnd, HWND hWndSend, HWND hWndTagt)
{
	GetWindowText(hWndSend, s_wk.name, sizeof(s_wk.name)/sizeof(TCHAR));
	GetClassName (hWndSend, s_wk.clas, sizeof(s_wk.clas)/sizeof(TCHAR));

	if (hWndTagt) {
		s_wk.id = GetWindowLong (hWndTagt, GWL_ID);
		GetClassName (hWndTagt, s_wk.idcs, sizeof(s_wk.idcs)/sizeof(TCHAR));
	}
	else {
		s_wk.id = -1;
		s_wk.idcs[0] = 0;
	}
	s_wk.key = MAKELONG('V', MOD_CONTROL);

	{
		int i;
		int idx = -1;
		for (i = 0; i < MAX_WNDTYP; i++) {
			if (lstrcmp(g_WndTyp[i].name, s_wk.name) == 0 &&
				lstrcmp(g_WndTyp[i].clas, s_wk.clas) == 0) {
				s_wk.id  = g_WndTyp[i].id;
				s_wk.key = g_WndTyp[i].key;
				break;
			}
		}
	}

	int rc = DialogBox (hInst, (LPCTSTR)IDD_DLG_WIN, hWnd, (DLGPROC)EntwinDlgProc);
	if (rc == IDOK || rc == IDC_BDEL) {
		int i;
		int idx = -1;
		for (i = 0; i < MAX_WNDTYP; i++) {
			if (g_WndTyp[i].name[0] == 0 && idx == -1)
				idx = i;
			if (lstrcmp(g_WndTyp[i].name, s_wk.name) == 0 &&
				lstrcmp(g_WndTyp[i].clas, s_wk.clas) == 0) {
				idx = i;
			}
		}
		if (idx != -1) {
			if (rc == IDC_BDEL) memset (&s_wk, 0, sizeof(s_wk));
			memcpy (&g_WndTyp[idx], &s_wk, sizeof(s_wk));
			SaveWndentry (hInst);
		}
		else {
			MessageBox (hWnd, _T("ȏEChEo^ł܂"), _T("PQBox"), MB_OK);
		}
	}
	return rc;
}
//---------------------------------------------------------------
//---------------------------------------------------------------
